// Query WINSOCK for information
//zacco

#include <winsock.h>
#include <conio.h>
#include <stdio.h>
#include <stdlib.h>

/* This is what the WSAData structure looks like for reference
struct WSAData{
	  WORD wVersion;				// expected Winsock version
	  WORD wHighVersion;			// highest compatabile version
	  char szDescription[WSADESCRIPTION_LEN + 1];	// vendor description
	  char szSystemStatus[WSASYS_STATUS_LEN + 1];	// system status & config
	  long iMaxSockets;			// maximum number of sockets available
	  long iMaxUdpDg;				// maximum datagram size
	  char FAR *lpVenderInfo;	// vender information string
} WSDATA;
*/

WSADATA WSDATA;



static char mstring[]="[z]\n";

void main(void)
{

  int rc, version=0x101; // you have to request a version - we use 1.1 here
  float nversion;

  printf("\t\t\t\tWINSOCK Query\n\n");
  if(mstring[1]!='z')  exit(1);
  rc=WSAStartup(version,&WSDATA);
  if(rc)
	 {
	 printf("WINSOCK Query ERROR:%d\n", rc);
	 WSACleanup();
	 exit(1);
	 }
  // we got it so print it out
  printf("- Winsock description -\n %-40s\n", WSDATA.szDescription);
  printf("\n- System status [if present] -\n %-40s\n", WSDATA.szSystemStatus);
  printf("\n- Vendor info   [if present] -\n %40s\n", WSDATA.lpVendorInfo);
  /*
  printf("Version %04x was requested - system expects version %04x to be used\n",
	version, WSDATA.wVersion); // this is pretty useless
  */
  // calculate the numeric version for asthetics
  nversion=((WSDATA.wHighVersion && 0xf0)+ (WSDATA.wHighVersion && 0x0f)*0.1);
  printf("\nHighest version this stack supports is %2.1f\n", nversion);
  printf("Maximum number of sockets available: %d\n",WSDATA.iMaxSockets);
  printf("Maximum datagram size: %d\n", WSDATA.iMaxUdpDg);
  printf("\n%s",mstring);
  WSACleanup();
  (void)getch();
  exit(0);
}

