// EthernetSpyHeaderFilterDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ethernetspy.h"
#include "packet32.h"
#include "EthernetSpyReader.h"
#include "filter.h"
#include "EthernetSpyHeaderFilterDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CEthernetSpyHeaderFilterDlg dialog


CEthernetSpyHeaderFilterDlg::CEthernetSpyHeaderFilterDlg(EthernetHeaderFilter* _Filter, CWnd* pParent /*=NULL*/)
	: CDialog(CEthernetSpyHeaderFilterDlg::IDD, pParent)
{
	Filter = _Filter;
	//{{AFX_DATA_INIT(CEthernetSpyHeaderFilterDlg)
	m_Dest = Filter->sDest;
	m_Type = Filter->sType;
	m_Source = Filter->sSource;
	//}}AFX_DATA_INIT
}


void CEthernetSpyHeaderFilterDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CEthernetSpyHeaderFilterDlg)
	DDX_Text(pDX, IDC_DEST_ADDR, m_Dest);
	DDX_Text(pDX, IDC_FRAME_TYPE, m_Type);
	DDX_Text(pDX, IDC_SOURCE_ADDR, m_Source);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CEthernetSpyHeaderFilterDlg, CDialog)
	//{{AFX_MSG_MAP(CEthernetSpyHeaderFilterDlg)
		// NOTE: the ClassWizard will add message map macros here
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEthernetSpyHeaderFilterDlg message handlers

BOOL CEthernetSpyHeaderFilterDlg::DestroyWindow() 
{
	Filter->SetSourceAddrFlt (m_Source);
	Filter->SetDestAddrFlt (m_Dest);
	Filter->SetPktTypeFlt  (m_Type);
	
	return CDialog::DestroyWindow();
}
