(*
GUIDClean, version 1.0
22-March-1999

Copyright (c) 1999 General Frenetics, Discorp. All rights reserved.

Author:     marek jedlinski; General Frenetics, Discorp.
E-mail:     <eristic@lodz.pdi.net>
Web URL:    http://www.lodz.pdi.net/~eristic/free/index.html


--------------------------------------------------------------------------

LICENSE, TERMS OF USE

This program is free software; it can be freely distributed and/or
modified under the terms of the `Artistic License' or the `GNU
General Public Licence', described in the two files `ARTISTIC.TXT'
and `GPL.TXT' respectively, which you should have received with the
program package. If you find these files are missing, I will be happy
to send them to you via email. You can also obtain a copy of the GNU
General Public License by writing to the Free Software Foundation, Inc.,
59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

The distribution method is intended to be compliant with the Open Source
Definition -- see: http://www.opensource.org

The software and all accompanying documentation are provided "as is",
and come with ABSOLUTELY NO WARRANTY of any kind, either express or
implied, without even the implied warranty of MERCHANTABILITY or FITNESS
FOR A PARTICULAR PURPOSE. If you use the contents of this distribution,
you do so at your own risk, and you agree to free the author(s) of any
consequences arising from such use, either intended or otherwise.

--------------------------------------------------------------------------
I hope you find this useful. Comments, suggestions and bug reports are
welcome, see my email address or home page, given on top of this document.

marek jedlinski
General Frenetics, Discorp.
--------------------------------------------------------------------------
*)

unit guid_about;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Menus, ClipBrd, ShellAPI;

type
  TForm_About = class(TForm)
    Image1: TImage;
    Button_OK: TButton;
    Bevel1: TBevel;
    Label1: TLabel;
    Label3: TLabel;
    Label2: TLabel;
    Label_MAILTO: TLabel;
    Label_URL: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    NetMenu: TPopupMenu;
    CopyEmailaddress1: TMenuItem;
    CopyuWebURL1: TMenuItem;
    N1: TMenuItem;
    Cancel1: TMenuItem;
    Label6: TLabel;
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure CopyEmailaddress1Click(Sender: TObject);
    procedure CopyuWebURL1Click(Sender: TObject);
    procedure Label_MAILTODblClick(Sender: TObject);
    procedure Label_URLDblClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form_About: TForm_About;

implementation

{$R *.DFM}

procedure TForm_About.FormKeyPress(Sender: TObject; var Key: Char);
begin
   case key of
       #27 : begin
           key := #0;
           Close;
       end;
   end;
end;

procedure TForm_About.CopyEmailaddress1Click(Sender: TObject);
begin
   // Copy Email
   Clipboard.SetTextBuf( PChar( Label_MAILTO.Caption ));
end;

procedure TForm_About.CopyuWebURL1Click(Sender: TObject);
begin
   // Copy URL
   Clipboard.SetTextBuf( PChar( Label_URL.Caption ));
end;

procedure TForm_About.Label_MAILTODblClick(Sender: TObject);
begin
   // Send Email
   screen.Cursor := crHourGlass;
   ShellExecute( 0, 'open', PChar( 'mailto:' + Label_MAILTO.Caption ), nil, nil, SW_NORMAL );
   screen.Cursor := crDefault;
end;

procedure TForm_About.Label_URLDblClick(Sender: TObject);
begin
   // GoTo URL
   screen.Cursor := crHourGlass;
   ShellExecute( 0, 'open', PChar( Label_URL.Caption ), nil, nil, SW_NORMAL );
   screen.Cursor := crDefault;
end;

end.
