// EthernetSpyTwoTalkFltDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ethernetspy.h"

#include "packet32.h"
#include "EthernetSpyReader.h"
#include "filter.h"
#include "EthernetSpyTwoTalkFltDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CEthernetSpyTwoTalkFltDlg dialog


CEthernetSpyTwoTalkFltDlg::CEthernetSpyTwoTalkFltDlg(TwoTalkingComputersFilter* _Filter, CWnd* pParent /*=NULL*/)
	: CDialog(CEthernetSpyTwoTalkFltDlg::IDD, pParent)
{
	Filter = _Filter;
	//{{AFX_DATA_INIT(CEthernetSpyTwoTalkFltDlg)
	m_AddrA = Filter->sAddrA;
	m_AddrB = Filter->sAddrB;
	//}}AFX_DATA_INIT
}


void CEthernetSpyTwoTalkFltDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CEthernetSpyTwoTalkFltDlg)
	DDX_Text(pDX, IDC_COMPUTER_A_ADDR, m_AddrA);
	DDV_MaxChars(pDX, m_AddrA, 12);
	DDX_Text(pDX, IDC_COMPUTER_B_ADDR, m_AddrB);
	DDV_MaxChars(pDX, m_AddrB, 12);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CEthernetSpyTwoTalkFltDlg, CDialog)
	//{{AFX_MSG_MAP(CEthernetSpyTwoTalkFltDlg)
		// NOTE: the ClassWizard will add message map macros here
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEthernetSpyTwoTalkFltDlg message handlers

BOOL CEthernetSpyTwoTalkFltDlg::DestroyWindow() 
{
	Filter->SetAddresses (m_AddrA, m_AddrB);
	
	return CDialog::DestroyWindow();
}
