// EthernetSpyView.h : interface of the CEthernetSpyView class
//
/////////////////////////////////////////////////////////////////////////////

class CEthernetSpyView : public CView
{
protected: // create from serialization only
	CEthernetSpyView();
	DECLARE_DYNCREATE(CEthernetSpyView)

// Attributes
public:
	CEthernetSpyDoc* GetDocument();

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CEthernetSpyView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CEthernetSpyView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CEthernetSpyView)
	afx_msg LRESULT OnSpyDlgClose(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnGlobStatsDlgClose(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnPckTypeDlgClose(WPARAM wParam, LPARAM lParam);
//	afx_msg LRESULT OnThreadTerminated(WPARAM wParam, LPARAM lParam);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in EthernetSpyView.cpp
inline CEthernetSpyDoc* CEthernetSpyView::GetDocument()
   { return (CEthernetSpyDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////
